@use '../../../../global/utilities' as *;
@use '../../../../global/styles-variables' as *;

:host {
  display: block;

  .digi-docs-color-token-cards {
    $base: &;
    --SWATCH--SIZE--BASE: #{rem(64)};
    --SWATCH--SIZE--LG: #{rem(125)};
    --TOKEN--FOOTER--HEIGHT: #{rem(60)};
    --TOKEN--FOOTER--HEIGHT--VARIATION: #{rem(20)};

    margin-bottom: var(--digi--margin--medium);

    &__color-swatches {
      display: grid;
      gap: var(--digi--padding--large);
      grid-template-columns: repeat(auto-fill, var(--SWATCH--SIZE--BASE));

      &--big {
        gap: var(--digi--padding--large);
        grid-template-columns: repeat(
          auto-fill,
          minmax(var(--SWATCH--SIZE--LG), 1fr)
        );
      }
    }

    &__list {
      &:not(:first-child) {
        margin-top: var(--digi--padding--larger);
      }
    }

    &__item {
      $token-item: &;

      display: block;
      margin-left: 0;
      --digi--card--footer--padding: 0;
      --digi--card--footer--border-top: none;

      &--variation {
        margin-left: var(--digi--padding--large);
        --TOKEN--FOOTER--HEIGHT: var(--TOKEN--FOOTER--HEIGHT--VARIATION);

        &:not(#{$token-item}--expanded) {
          --digi--card--padding: 0;
        }
      }
    }

    &__content {
      display: grid;
      column-gap: var(--digi--padding--large);
      grid-template-columns:
        minmax(min-content, var(--digi--paragraph-width--medium))
        auto;
      width: 100%;

      &[aria-hidden='true'] {
        display: none;
      }

      @media screen and (max-width: $digi--breakpoint--medium-below) {
        grid-template-columns: 1fr;
        row-gap: var(--digi--padding--large);
      }
    }

    &__content-end {
      margin-left: auto;
      display: flex;
      flex-direction: column;
      align-items: flex-end;
    }

    &__header {
      display: flex;
      flex-basis: 100%;
      align-items: center;
      column-gap: var(--digi--padding--large);

      > div {
        display: flex;
        align-items: baseline;
        column-gap: var(--digi--padding--large);
      }

      h3 {
        margin: 0;
      }

      p {
        margin: 0;
      }
    }

    &__footer {
      display: block;
      width: 100%;
      overflow: hidden;
      height: var(--TOKEN--FOOTER--HEIGHT);
      background: var(--TOKEN--FOOTER--COLOR, transparent);
    }

    &__comment {
      margin-bottom: var(--digi--padding--small);
      margin-top: 0.5rem;
    }

    &__token {
      margin-top: var(--digi-typography--margin--text);
      margin-top: var(--digi--padding--small);
    }

    &__print-data {
      display: flex;
      flex-wrap: wrap;

      --BOTTOM-MARGIN: 0;

      @media screen and (max-width: $digi--breakpoint--medium-below) {
        flex-direction: column;
        --BOTTOM-MARGIN: var(--digi--margin--medium);
      }

      dt {
        padding: 0;
        margin: 0 var(--digi--margin--smaller) 0 0;
        font-weight: var(--digi--typography--label--font-weight--desktop);
      }
      dd {
        padding: 0;
        margin: 0 var(--digi--margin--large) var(--BOTTOM-MARGIN) 0;
      }
    }

    &__swatch-list {
      display: flex;
      flex-wrap: wrap;
      gap: var(--digi--padding--small);
    }

    &__toggle-btn {
      margin-left: auto;
      margin-right: -#{rem(20)};
    }

    &__toggle-btn-text {
      // @include digi--a11y--sr-only;

      span {
        display: none;
      }
    }
  }
}

::slotted(
    *
      .digi-docs-color-token-cards
      digi-button.digi-docs-color-token-cards__toggle-btn
  ) {
  button[aria-expanded='false'] {
    .digi-docs-color-token-cards__toggle-btn-text span:first-child {
      display: inline-block;
    }
  }

  button[aria-expanded='true'] {
    .digi-docs-color-token-cards__toggle-btn-text span:last-child {
      display: inline-block;
    }

    .digi-button__icon {
      transform: rotate(-180deg);
    }
  }
}
